#include <memory>
#include <map>
#include <QTextEdit>
#include <QPushButton>
#include <QMainWindow>
#include <QListWidget>
#include <QStackedWidget>

#include "disassembler/Disassembler.hxx"
#include "widgets/BasicBlockWidget.hxx"

class Mainwindow : public QMainWindow {
    Q_OBJECT
public:
    Mainwindow(const std::string& filename = "");
private:
	void openBinary(const std::string& filename);

    void populateSymbolInformation(Function * fun);

    QTextEdit *textEdit;
    QPushButton *quitButton;
    QMenu *fileMenu;

    QTabWidget * tabwidget;
    QListWidget * listWidget;
    QStackedWidget * stackedWidget;
    QDockWidget * dockWidget;

    QAction *exitAction;
    QAction *openAction;

    std::shared_ptr<Disassembler> disassembler;
	std::map<uint64_t, BasicBlockWidget*> blocks;
private slots:
    void quit();
    void open();
};
